#  V767.defn.tcl

proc {Add_CAEN V767_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME GEO_Address         "-a$A32addrbase -w32 -o0x4 -prw -d16 -l5 -b0 -zx -i$moduleID"
   define-vme-register $name xVME Bit_Set             "-a$A32addrbase -w32 -o0x6 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Bit_Clear           "-a$A32addrbase -w32 -o0x8 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Intr_Level          "-a$A32addrbase -w32 -o0xa -prw -d16 -l3 -b0 -zd -i$interruptlevel"
   define-vme-register $name xVME Intr_Vec            "-a$A32addrbase -w32 -o0xc -prw -d16 -l8 -b0 -zd -i$interruptvector"

   define-vme-register $name xVME Status1             "-a$A32addrbase -w32 -o0xe -pro -d16 -l8 -b0 -zx"

   define-vme-register $name xVME Ctrl1               "-a$A32addrbase -w32 -o0x10 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ADER_HIGH           "-a$A32addrbase -w32 -o0x12 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ADER_LOW            "-a$A32addrbase -w32 -o0x14 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME MCST/CBLT_Address   "-a$A32addrbase -w32 -o0x16 -prw -d16 -l8 -b0 -zx -i0xAA"
   define-vme-register $name xVME MCST/CBLT_Ctrl      "-a$A32addrbase -w32 -o0x20 -pwo -d16 -l2 -b0 -zx"

   define-vme-register $name xVME Status2             "-a$A32addrbase -w32 -o0x48 -pro -d16 -l0 -b0 -zx"

   define-vme-register $name xVME Ctrl2               "-a$A32addrbase -w32 -o0x4a -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Ctrl2.AcqMode       "-a$A32addrbase -w32 -o0x4a -pro -d16 -l2 -b0 -zx"
   define-vme-register $name xVME Ctrl2.DrMode        "-a$A32addrbase -w32 -o0x4a -pro -d16 -l2 -b2 -zx"

   define-vme-register $name xVME EvCounter           "-a$A32addrbase -w32 -o0x4c -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME EvCounterClr        "-a$A32addrbase -w32 -o0x4e -prw -d16 -l0 -b0 -zx"

   define-vme-register $name xVME OpCodeCtrl          "-a$A32addrbase -w32 -o0x50 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OpCode              "-a$A32addrbase -w32 -o0x52 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OpCode_Cmd          "-a$A32addrbase -w32 -o0x52 -prw -d16 -l8 -b8 -zx"
   define-vme-register $name xVME OpCode_Obj          "-a$A32addrbase -w32 -o0x52 -prw -d16 -l8 -b0 -zx"

   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x54 -prw -d16 -l0 -b0 -zx"

   define-vme-register $name xVME Mem_Test_High       "-a$A32addrbase -w32 -o0x56 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Mem_Test_Low        "-a$A32addrbase -w32 -o0x58 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME SoftTrig            "-a$A32addrbase -w32 -o0x5a -prw -d16 -l0 -b0 -zx"

   define-vme-register $name xVME ROM.OUI_MSB         "-a$A32addrbase -w32 -o0x1026 -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.OUI             "-a$A32addrbase -w32 -o0x102a -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.OUI_LSB         "-a$A32addrbase -w32 -o0x102e -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.Version         "-a$A32addrbase -w32 -o0x1032 -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.BID_MSB         "-a$A32addrbase -w32 -o0x1036 -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.BID             "-a$A32addrbase -w32 -o0x103a -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.BID_LSB         "-a$A32addrbase -w32 -o0x103e -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.Rev             "-a$A32addrbase -w32 -o0x104e -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.Ser_MSB         "-a$A32addrbase -w32 -o0x1f02 -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ROM.Ser_LSB         "-a$A32addrbase -w32 -o0x1f06 -pro -d16 -l8 -b0 -zx"

   define-vme-register $name bVME Output_Buffer       "-a$A32addrbase -w32 -o0x0 -pro -d32 -zx -l64"
   define-vme-register $name xVME Output_Word         "-a$A32addrbase -w32 -o0x0 -pro -d32 -l0 -b0 -zx"

}

proc {CAEN V767_registers} {} {
    global registers_table

    set registers_table   {                                              \
        {"GEO Address Register"                GEO_Address}              \
        {"Bit Set Register"                    Bit_Set}                  \
        {"Bit Clear Register"                  Bit_Clear}                \
        {"Interrupt Level Register"            Intr_Level}               \
        {"Interrupt Vector Register"           Intr_Vec}                 \
        {"Status Register 1"                   Status1}                  \
        {"Control Register 1"                  Ctrl1}                    \
        {"Address Decoder High Register"       ADER_HIGH}                \
        {"Address Decoder Low Register"        ADER_LOW}                 \
        {"MCST/CBLT Address Register"          MCST/CBLT_Address}        \
        {"MCST/CBLT Control Register"          MCST/CBLT_Ctrl}           \
        {"Status Register 2"                   Status2}                  \
        {"Control Register 2"                  Ctrl2}                    \
        {"Event Counter Register"              EvCounter}                \
        {"Op Code Handshake Register"          OpCodeCtrl}               \
        {"Op Code Register"                    OpCode}                   \
        {"ROM OUI MSB"                         ROM.OUI_MSB}              \
        {"ROM OUI"                             ROM.OUI}                  \
        {"ROM OUI LSB"                         ROM.OUI_LSB}              \
        {"ROM Version"                         ROM.Version}              \
        {"ROM Board ID MSB"                    ROM.BID_MSB}              \
        {"ROM Board ID"                        ROM.BID}                  \
        {"ROM Board ID LSB"                    ROM.BID_LSB}              \
        {"ROM Revision"                        ROM.Rev}                  \
        {"ROM Serial MSB"                      ROM.Ser_MSB}              \
        {"ROM Serial LSB"                      ROM.Ser_LSB}              \
    }
}

proc {CAEN V767_DAQ-reset} {args} {
#   V767
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ROM.Rev] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

#    software reset the board
    write-vme-register $module.Bit_Set 0x80
    write-vme-register $module.Bit_Clear 0x80

    after 2000
}

proc {CAEN V767_DAQ-flush} {args} {
#   V767
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
    write-vme-register $module.Clear 0
}

proc {CAEN V767_DAQ-go} {args} {
#   V767
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
    write-vme-register $module.Clear 0
}

proc {CAEN V767_DAQ-halt} {args} {
#   V767
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V767_DAQ-setup} {args} {
#   V767
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    software reset the board
    write-vme-register $module.Bit_Set 0x80
    write-vme-register $module.Bit_Clear 0x80

    after 2000

#    initialise 
    initialise-vme-registers $module.GEO_Address
}

#   for parameter save/restore
set {CAEN V767_registersavepatterns} {}


